import java.lang.Math;

public class Network
{
	private double alpha = 6.0; /* Rate of learning, essentially */
	
	private double right_outputX;
	private double left_outputX;
	private double in_left, in_right;
	private double inl1, inl2, inr1, inr2;
	private double right_resultX;
	private double left_resultX;
	private double theta;
	private double theta_dot;
	
	/* Weights */
	private double l_thetain;
	private double l_thetadotin;
	private double r_thetain;
	private double r_thetadotin;
	
	/* Thresholds */
//	private int t_left;
//	private int t_right;
	
	private double outputX;
	
	public Network()
		// Constructor
	{
		/* Initialize weights */
	/*	l_thetain = -3;
		l_thetadotin = -3;
		r_thetain = 3;
		r_thetadotin = 3;		
*/
		l_thetain = 0;
		l_thetadotin = 0;
		r_thetain = 0;
		r_thetadotin = 0;			
	}

	private double sigmoid(double x) {
		return 1.0 / (1.0 + Math.exp(-x));
	}

	private double sigmoidDerivative(double x) {
		return (sigmoid(x) * (1 - sigmoid(x)));
	}	
	
	private double runLeft(Position p)
	{
		inl1 = l_thetain * p.theta;
		inl2 = l_thetadotin * p.theta_dot;
		in_left= inl1 + inl2;
		left_outputX = sigmoid(in_left);
		return left_outputX;
	}
	
	private double runRight(Position p)
	{
		inr1 = r_thetain * p.theta;
		inr2 = r_thetadotin * p.theta_dot;;
		in_right = inr1 + inr2;		
		right_outputX = sigmoid(in_right);
		return right_outputX;
	}
	
	private int getMove(double right_outputX, double left_outputX)
	{
		outputX = right_outputX - left_outputX;
		System.out.println("OutputX = " + outputX);
		if (outputX > 0.5)
			return 1;
		else if (outputX < -0.5)
			return -1;
		else
			return 0;		
	}
	
	public int makeMove(Position p)
	{
		right_outputX = runRight(p);
		left_outputX = runLeft(p);
		theta = p.theta;
		theta_dot = p.theta_dot;
		return getMove(right_outputX, left_outputX);
	}
	
	public void updateNet()
		// Updates all the weights in the network
	{
//		l_thetain = l_thetain + theta * (left_resultX - left_outputX)* alpha * sigmoidDerivative(in_left);
//		l_thetadotin = l_thetadotin + theta_dot * (left_resultX - left_outputX)* alpha * sigmoidDerivative(in_left);
//		r_thetain = r_thetain + theta * (right_resultX - right_outputX)* alpha * sigmoidDerivative(in_right);
//		r_thetadotin = r_thetadotin + theta_dot * (right_resultX - right_outputX)* alpha * sigmoidDerivative(in_right);
		l_thetain = l_thetain + theta * (-theta)* alpha * sigmoidDerivative(in_left);
		l_thetadotin = l_thetadotin + theta_dot * (-theta)* alpha * sigmoidDerivative(in_left);
		r_thetain = r_thetain + theta * (theta)* alpha * sigmoidDerivative(in_right);
		r_thetadotin = r_thetadotin + theta_dot * (theta)* alpha * sigmoidDerivative(in_right);
		System.out.println("lth = " + l_thetain + " lthdot = " + l_thetadotin + " rth = " + r_thetain + " rthdot = " + r_thetadotin);
	}
	
	public void getRes(int res)
		/*
		res = -1 : fell left
		res = 0 : remained upright
		res = 1 : fell right
		 */
	{
	//	right_resultX = theta;
	//	left_resultX = -theta;
		if (res == 0)
		{
			right_resultX = right_outputX;
			left_resultX = left_outputX;
	//		right_resultX = 0;
	//		left_resultX = 0;
		}
		else if (res == 1)
		{
			right_resultX = 1.1;
			left_resultX = 0.0;
		}
		else if (res == -1)
		{
			right_resultX = 0.0;
			left_resultX = 1.1;			
		}
		else
			System.out.println("An invalid value was passed to getRes() ");

	}
	
	
}